import { useCallback, useEffect } from 'react';
import { useStableCallback } from './use-stable-callback';
export var stacks = {};
export function useNotice() {
  var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var callback = arguments.length > 1 ? arguments[1] : undefined;
  var cbk = useStableCallback(function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    return callback === null || callback === void 0 ? void 0 : callback.apply(void 0, args);
  });
  useEffect(function () {
    if (id && callback) {
      var stack = stacks[id];
      if (stack) {
        stack.callbacks.push(cbk);
        cbk === null || cbk === void 0 ? void 0 : cbk(stack.action);
      } else {
        stacks[id] = {
          callbacks: [cbk]
        };
      }
      return function () {
        if (stack) {
          stack.callbacks = stack.callbacks.filter(function (cb) {
            return cb !== cbk;
          });
        }
      };
    }
    return function () {};
  }, []);
  // 分发消息
  var distribute = useCallback(function (key, action) {
    var stack = stacks[key];
    if (stack) {
      stack.callbacks.forEach(function (cb) {
        cb === null || cb === void 0 ? void 0 : cb(action);
      });
      stack.action = action;
    } else {
      stacks[key] = {
        callbacks: [],
        action: action
      };
    }
  }, []);
  var dispatch = useCallback(function (action, targetId) {
    if (typeof targetId === 'string') {
      distribute(targetId, action);
    } else {
      Object.keys(stacks).forEach(function (key) {
        distribute(key, action);
      });
    }
  }, []);
  return {
    dispatch: dispatch
  };
}