import { useCallback, useLayoutEffect, useRef } from 'react';
export function useStableCallback(callback) {
  var cbRef = useRef(callback);
  useLayoutEffect(function () {
    cbRef.current = callback;
  });
  return useCallback(function () {
    return cbRef.current.apply(cbRef, arguments);
  }, [cbRef]);
}