function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useEffect, useLayoutEffect, useRef, useState } from 'react';
import { useResize } from './use-resize';
import { useScale } from './use-scale';
function getElement(target) {
  if ('current' in target) {
    return target.current;
  }
  return target;
}
export function useTargetScale() {
  var keepSize = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
  var container = useRef(null);
  var target = useRef(null);
  var _useState = useState({
      width: 0,
      height: 0
    }),
    _useState2 = _slicedToArray(_useState, 2),
    containerSize = _useState2[0],
    setContainerSize = _useState2[1];
  var _useState3 = useState(),
    _useState4 = _slicedToArray(_useState3, 2),
    targetSize = _useState4[0],
    setTargetSize = _useState4[1];
  var _useState5 = useState(null),
    _useState6 = _slicedToArray(_useState5, 2),
    containerEl = _useState6[0],
    setContainerEl = _useState6[1];
  var _useState7 = useState(null),
    _useState8 = _slicedToArray(_useState7, 2),
    targetEl = _useState8[0],
    setTargetEl = _useState8[1];
  useEffect(function () {
    setContainerEl(getElement(container));
  }, [container]);
  useEffect(function () {
    setTargetEl(getElement(target));
  }, [target]);
  useResize({
    el: containerEl,
    onResize: function onResize(_ref) {
      var _ref$contentRect = _ref.contentRect,
        width = _ref$contentRect.width,
        height = _ref$contentRect.height;
      setContainerSize({
        width: width,
        height: height
      });
    }
  });
  useLayoutEffect(function () {
    if (targetEl) {
      var width = targetEl.offsetWidth,
        height = targetEl.offsetHeight;
      setTargetSize({
        width: width,
        height: height
      });
    }
  }, [targetEl]);
  var scale = useScale(containerSize, targetSize, keepSize);
  return {
    scale: scale,
    container: container,
    target: target
  };
}